/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.assume.adaptors.gitlab.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.assume.adaptors.gitlab.servlet.ServletListener;
import se.kth.md.assume.adaptors.gitlab.GitLabConstants;
import se.kth.md.assume.adaptors.gitlab.resources.FolderResource;
import se.kth.md.assume.adaptors.gitlab.resources.Person;

// Start of user code imports
// End of user code

// Start of user code preClassCode
// End of user code

// Start of user code classAnnotations
// End of user code
@OslcNamespace(GitLabConstants.FILE_MANAGEMENT_NAMSPACE)
@OslcName(GitLabConstants.FILERESOURCE)
@OslcResourceShape(title = "FileResource Resource Shape", describes = GitLabConstants.TYPE_FILERESOURCE)
public class FileResource
    extends AbstractResource
    implements IFileResource
{
    // Start of user code attributeAnnotation:created
    // End of user code
    private Date created;
    // Start of user code attributeAnnotation:title
    // End of user code
    private String title;
    // Start of user code attributeAnnotation:modfied
    // End of user code
    private Date modfied;
    // Start of user code attributeAnnotation:fileSize
    // End of user code
    private Integer fileSize;
    // Start of user code attributeAnnotation:creator
    // End of user code
    private Link creator = new Link();
    // Start of user code attributeAnnotation:previewURL
    // End of user code
    private URI previewURL;
    // Start of user code attributeAnnotation:containerFolder
    // End of user code
    private Link containerFolder = new Link();
    // Start of user code attributeAnnotation:downloadURL
    // End of user code
    private URI downloadURL;
    
    // Start of user code classAttributes
    // End of user code
    // Start of user code classMethods
    // End of user code
    public FileResource()
           throws URISyntaxException
    {
        super();
    
        // Start of user code constructor1
        // End of user code
    }
    
    public FileResource(final URI about)
           throws URISyntaxException
    {
        super(about);
    
        // Start of user code constructor2
        // End of user code
    }
    
    public FileResource(final String serviceProviderId, final String resourceId)
           throws URISyntaxException
    {
        this (constructURI(serviceProviderId, resourceId));
        // Start of user code constructor3
        // End of user code
    }
    
    public static URI constructURI(final String serviceProviderId, final String resourceId)
    {
        String basePath = ServletListener.getServicesBase();
        Map<String, Object> pathParameters = new HashMap<String, Object>();
        pathParameters.put("serviceProviderId", serviceProviderId);
        pathParameters.put("resourceId", resourceId);
        String instanceURI = "fm-services/{serviceProviderId}/resources/fileResources/{resourceId}";
    
        final UriBuilder builder = UriBuilder.fromUri(basePath);
        return builder.path(instanceURI).buildFromMap(pathParameters);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId , final String label)
    {
        return new Link(constructURI(serviceProviderId, resourceId), label);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId)
    {
        return new Link(constructURI(serviceProviderId, resourceId));
    }
    
    public String toString()
    {
        return toString(false);
    }
    
    public String toString(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toString_init
        // End of user code
    
        if (asLocalResource) {
            result = result + "{a Local FileResource Resource} - update FileResource.toString() to present resource as desired.";
            // Start of user code toString_bodyForLocalResource
            // End of user code
        }
        else {
            result = getAbout().toString();
        }
    
        // Start of user code toString_finalize
        // End of user code
    
        return result;
    }
    
    public String toHtml()
    {
        return toHtml(false);
    }
    
    public String toHtml(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toHtml_init
        // End of user code
    
        if (asLocalResource) {
            result = toString(true);
            // Start of user code toHtml_bodyForLocalResource
            // End of user code
        }
        else {
            result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
        }
    
        // Start of user code toHtml_finalize
        // End of user code
    
        return result;
    }
    
    
    // Start of user code getterAnnotation:created
    // End of user code
    @OslcName("created")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "created")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.DateTime)
    @OslcReadOnly(false)
    @OslcTitle("")
    public Date getCreated()
    {
        // Start of user code getterInit:created
        // End of user code
        return created;
    }
    
    // Start of user code getterAnnotation:title
    // End of user code
    @OslcName("title")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "title")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.XMLLiteral)
    @OslcReadOnly(false)
    public String getTitle()
    {
        // Start of user code getterInit:title
        // End of user code
        return title;
    }
    
    // Start of user code getterAnnotation:modfied
    // End of user code
    @OslcName("modfied")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "modfied")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.DateTime)
    @OslcReadOnly(false)
    @OslcTitle("")
    public Date getModfied()
    {
        // Start of user code getterInit:modfied
        // End of user code
        return modfied;
    }
    
    // Start of user code getterAnnotation:fileSize
    // End of user code
    @OslcName("fileSize")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "fileSize")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.Integer)
    @OslcReadOnly(false)
    public Integer getFileSize()
    {
        // Start of user code getterInit:fileSize
        // End of user code
        return fileSize;
    }
    
    // Start of user code getterAnnotation:creator
    // End of user code
    @OslcName("creator")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "creator")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.Resource)
    @OslcRange({GitLabConstants.TYPE_PERSON})
    @OslcReadOnly(false)
    public Link getCreator()
    {
        // Start of user code getterInit:creator
        // End of user code
        return creator;
    }
    
    // Start of user code getterAnnotation:previewURL
    // End of user code
    @OslcName("previewURL")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "previewURL")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcReadOnly(false)
    public URI getPreviewURL()
    {
        // Start of user code getterInit:previewURL
        // End of user code
        return previewURL;
    }
    
    // Start of user code getterAnnotation:containerFolder
    // End of user code
    @OslcName("containerFolder")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "containerFolder")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.Resource)
    @OslcRange({GitLabConstants.TYPE_FOLDERRESOURCE})
    @OslcReadOnly(false)
    public Link getContainerFolder()
    {
        // Start of user code getterInit:containerFolder
        // End of user code
        return containerFolder;
    }
    
    // Start of user code getterAnnotation:downloadURL
    // End of user code
    @OslcName("downloadURL")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "downloadURL")
    @OslcDescription("")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcReadOnly(false)
    public URI getDownloadURL()
    {
        // Start of user code getterInit:downloadURL
        // End of user code
        return downloadURL;
    }
    
    
    // Start of user code setterAnnotation:created
    // End of user code
    public void setCreated(final Date created )
    {
        // Start of user code setterInit:created
        // End of user code
        this.created = created;
    
        // Start of user code setterFinalize:created
        // End of user code
    }
    
    // Start of user code setterAnnotation:title
    // End of user code
    public void setTitle(final String title )
    {
        // Start of user code setterInit:title
        // End of user code
        this.title = title;
    
        // Start of user code setterFinalize:title
        // End of user code
    }
    
    // Start of user code setterAnnotation:modfied
    // End of user code
    public void setModfied(final Date modfied )
    {
        // Start of user code setterInit:modfied
        // End of user code
        this.modfied = modfied;
    
        // Start of user code setterFinalize:modfied
        // End of user code
    }
    
    // Start of user code setterAnnotation:fileSize
    // End of user code
    public void setFileSize(final Integer fileSize )
    {
        // Start of user code setterInit:fileSize
        // End of user code
        this.fileSize = fileSize;
    
        // Start of user code setterFinalize:fileSize
        // End of user code
    }
    
    // Start of user code setterAnnotation:creator
    // End of user code
    public void setCreator(final Link creator )
    {
        // Start of user code setterInit:creator
        // End of user code
        this.creator = creator;
    
        // Start of user code setterFinalize:creator
        // End of user code
    }
    
    // Start of user code setterAnnotation:previewURL
    // End of user code
    public void setPreviewURL(final URI previewURL )
    {
        // Start of user code setterInit:previewURL
        // End of user code
        this.previewURL = previewURL;
    
        // Start of user code setterFinalize:previewURL
        // End of user code
    }
    
    // Start of user code setterAnnotation:containerFolder
    // End of user code
    public void setContainerFolder(final Link containerFolder )
    {
        // Start of user code setterInit:containerFolder
        // End of user code
        this.containerFolder = containerFolder;
    
        // Start of user code setterFinalize:containerFolder
        // End of user code
    }
    
    // Start of user code setterAnnotation:downloadURL
    // End of user code
    public void setDownloadURL(final URI downloadURL )
    {
        // Start of user code setterInit:downloadURL
        // End of user code
        this.downloadURL = downloadURL;
    
        // Start of user code setterFinalize:downloadURL
        // End of user code
    }
    
    
    static public String createdToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:createdToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"created\">created: </LABEL>";
    
        // Start of user code "Mid:createdToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"created\" type=\"text\" style=\"width: 400px\" id=\"created\" >";
        // Start of user code "Finalize:createdToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String titleToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:titleToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"title\">title: </LABEL>";
    
        // Start of user code "Mid:titleToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"title\" type=\"text\" style=\"width: 400px\" id=\"title\" >";
        // Start of user code "Finalize:titleToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String modfiedToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:modfiedToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"modfied\">modfied: </LABEL>";
    
        // Start of user code "Mid:modfiedToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"modfied\" type=\"text\" style=\"width: 400px\" id=\"modfied\" >";
        // Start of user code "Finalize:modfiedToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String fileSizeToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:fileSizeToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"fileSize\">fileSize: </LABEL>";
    
        // Start of user code "Mid:fileSizeToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"fileSize\" type=\"text\" style=\"width: 400px\" id=\"fileSize\" >";
        // Start of user code "Finalize:fileSizeToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String creatorToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:creatorToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"creator\">creator: </LABEL>";
    
        // Start of user code "Mid:creatorToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:creatorToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String previewURLToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:previewURLToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"previewURL\">previewURL: </LABEL>";
    
        // Start of user code "Mid:previewURLToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"previewURL\" type=\"text\" style=\"width: 400px\" id=\"previewURL\" >";
        // Start of user code "Finalize:previewURLToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String containerFolderToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:containerFolderToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"containerFolder\">containerFolder: </LABEL>";
    
        // Start of user code "Mid:containerFolderToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:containerFolderToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String downloadURLToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:downloadURLToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"downloadURL\">downloadURL: </LABEL>";
    
        // Start of user code "Mid:downloadURLToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"downloadURL\" type=\"text\" style=\"width: 400px\" id=\"downloadURL\" >";
        // Start of user code "Finalize:downloadURLToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    
    public String createdToHtml()
    {
        String s = "";
    
        // Start of user code createdtoHtml_init
        // End of user code
    
        s = s + "<label for=\"created\"><strong>created</strong>: </LABEL>";
    
        // Start of user code createdtoHtml_mid
        // End of user code
    
        try {
            if (created == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + created.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code createdtoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String titleToHtml()
    {
        String s = "";
    
        // Start of user code titletoHtml_init
        // End of user code
    
        s = s + "<label for=\"title\"><strong>title</strong>: </LABEL>";
    
        // Start of user code titletoHtml_mid
        // End of user code
    
        try {
            if (title == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + title.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code titletoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String modfiedToHtml()
    {
        String s = "";
    
        // Start of user code modfiedtoHtml_init
        // End of user code
    
        s = s + "<label for=\"modfied\"><strong>modfied</strong>: </LABEL>";
    
        // Start of user code modfiedtoHtml_mid
        // End of user code
    
        try {
            if (modfied == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + modfied.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code modfiedtoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String fileSizeToHtml()
    {
        String s = "";
    
        // Start of user code fileSizetoHtml_init
        // End of user code
    
        s = s + "<label for=\"fileSize\"><strong>fileSize</strong>: </LABEL>";
    
        // Start of user code fileSizetoHtml_mid
        // End of user code
    
        try {
            if (fileSize == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + fileSize.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code fileSizetoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String creatorToHtml()
    {
        String s = "";
    
        // Start of user code creatortoHtml_init
        // End of user code
    
        s = s + "<label for=\"creator\"><strong>creator</strong>: </LABEL>";
    
        // Start of user code creatortoHtml_mid
        // End of user code
    
        try {
            s = s + (new Person (creator.getValue())).toHtml(false);
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code creatortoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String previewURLToHtml()
    {
        String s = "";
    
        // Start of user code previewURLtoHtml_init
        // End of user code
    
        s = s + "<label for=\"previewURL\"><strong>previewURL</strong>: </LABEL>";
    
        // Start of user code previewURLtoHtml_mid
        // End of user code
    
        try {
            if (previewURL == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + previewURL.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code previewURLtoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String containerFolderToHtml()
    {
        String s = "";
    
        // Start of user code containerFoldertoHtml_init
        // End of user code
    
        s = s + "<label for=\"containerFolder\"><strong>containerFolder</strong>: </LABEL>";
    
        // Start of user code containerFoldertoHtml_mid
        // End of user code
    
        try {
            s = s + (new FolderResource (containerFolder.getValue())).toHtml(false);
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code containerFoldertoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String downloadURLToHtml()
    {
        String s = "";
    
        // Start of user code downloadURLtoHtml_init
        // End of user code
    
        s = s + "<label for=\"downloadURL\"><strong>downloadURL</strong>: </LABEL>";
    
        // Start of user code downloadURLtoHtml_mid
        // End of user code
    
        try {
            if (downloadURL == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + downloadURL.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code downloadURLtoHtml_finalize
        // End of user code
    
        return s;
    }
    
    
}
